#include <stdlib.h>
#include <string.h>
#include "tcl.h"

static int maxHandleProc(ClientData clientData, Tcl_Interp* interp,
                         int argc, char* argv[]){
  int  i;
  double maxvalue = 0;
  char result[200];

  if(argc == 1){
    sprintf(result, "Ootto! too few arguments, usage:%s num num...",
            argv[0]);
    Tcl_SetResult(interp, result, TCL_VOLATILE);
    return TCL_ERROR;
  }
  for(i=1; i<argc; i++){
    double v;
    if(sscanf(argv[i], "%lf", & v) == 0){
      sprintf(result, "Ootto! not numeric argument: %-100s", argv[i]);
      Tcl_SetResult(interp, result, TCL_VOLATILE);
      return TCL_ERROR;
    }
    if(i == 1 || v > maxvalue) maxvalue = v;
  }
  sprintf(result, "%g", maxvalue);
  Tcl_SetResult(interp, result, TCL_VOLATILE);
  return TCL_OK;
}

DLLEXPORT int Max_Init(Tcl_Interp* interp){
#ifdef USE_TCL_STUBS
  Tcl_InitStubs(interp, "8.1", 0);
#endif
  Tcl_CreateCommand(interp, "max", maxHandleProc, NULL, NULL);
  return Tcl_PkgProvide(interp, "max", "0.10");
}
/* end. */
